function X = SMTMultiply(SMTArray, X)
% The function computes 
%          Y = SMT*X
%
% where SMTArray is an array of rotations.

[N,M] = size(X);

[NumRotations,junk] = size(SMTArray);

for k=NumRotations:-1:1
  i = SMTArray(k,1);
  j = SMTArray(k,2);
  cos_theta = cos(SMTArray(k,3));
  sin_theta = sin(SMTArray(k,3));

  % X = T_k *X
  ri =  X(i,:)*cos_theta - X(j,:)*sin_theta; 
  rj =  X(i,:)*sin_theta + X(j,:)*cos_theta;
  X(i,:) = ri;
  X(j,:) = rj;
end

